/**
 * A class to define the Service object needed to be serialized
 * by Hadoop's architecture.
 *<p>
 * Last Updated: 22 July 2008
 *<p>
 * @author Kylie McCormick
 * @version 3.0
 */
package edu.arsc.multisearch;

import java.io.IOException;
import java.io.DataInputStream;
import java.io.InputStream;
import java.io.DataOutputStream;
import java.io.OutputStream;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.conf.*;
import org.apache.hadoop.io.*;
import org.apache.hadoop.mapred.*;
import org.apache.hadoop.util.*;
import java.util.StringTokenizer;

public class ServiceWritable implements Writable {

    /** URI of service */
    private String URL;

    /** Client class needed for service. */
    private String clientClass;

    /** The special name (specific to TREC or otherwise) for this service.*/
    private String name;

    /**
     * This must be overwritten for Hadoop.
     *
     * @param java.io.DataInput
     */     
    public void readFields(java.io.DataInput input) throws IOException {


	try {

	    String line = input.readLine();
	    StringTokenizer st = new StringTokenizer(line, "=");

	    //Document Collection
	    while(st.hasMoreTokens()){

		this.URL = st.nextToken();
		this.clientClass = st.nextToken();
		this.name = st.nextToken();

	    }

	} catch(java.io.IOException ioe) {

	    ioe.printStackTrace();

	}


    }

   /**
    * This must be overwritten for Hadoop.
    *
    * @param java.io.DataOutput
    */   
    public void write(java.io.DataOutput output) throws IOException {

	try {

	    if(name.equals("")) {

		name = "unknown";

	    }
	    
	    if(URL.equals("")) {
			
		URL = "unknown";

	    }

	    if(clientClass.equals("")) {

		clientClass = "unknown";

	    }

	    String lineInput = URL + "=" + clientClass + "=" + name + "\n";
	    

	    output.writeBytes(lineInput);


	} catch(java.io.IOException ioe) {

	    ioe.printStackTrace();

	}


    }

    /**
     *
     */
    public ServiceWritable() {

	name = "empty instance";
	clientClass = "";
	URL = "";

    }


    /**
     * Set the spec name for this.
     *
     * @param String name
     */
    public void setName(String name) {

	this.name = name;

    }

    /**
     * Sets the results.
     *
     * @param DocumentWritable[] documents
     
    public void setResults(DocumentWritable[] docs) {

	rsw.setResults(docs);

    }
    */

    /**
     * @return String name
     */
    public String getName() {

	return(name);

    }


    /**
     * Sets the URI value for the service.
     *
     * @param String URI
     */
    public void setURL(String URL) {

	this.URL = URL;

    }

    /**
     * Sets the clientClass value for the service.
     *
     * @param String clientClass
     */
    public void setClientClass(String clientClass) {

	this.clientClass = clientClass;

    }

    /**
     * Gets the clientClass value for this service.
     *
     * @return String clientClass
     */
    public String getClientClass() {

	return(clientClass);

    }


    /**
     * Gets the URI value for this service.
     *
     * @return String URI
     */
    public String getURL() {

	return(URL);

    }

    /**
     * This allows for easy access to documents wrapped in resultset.
     *
     * @return ResultSetWritable
     *
    public ResultSetWritable get() {

	return(rsw);

    }
*/

    /**
     * Easy access!
     *
     * @param ResultSetWritable
     * 
     public void set(ResultSetWritable rsw) {

	 this.rsw = rsw;

	 }*/

}
