/**
 * A base class for Server-Selection algorithms (aka Restricton algorithms
 * to extend for later use.
 *
 * @author Kylie McCormick
 * @version 3.0
 */
package edu.arsc.multisearch.select;

import java.io.File;
import java.util.Random;
import java.io.BufferedWriter;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import edu.arsc.multisearch.Multisearch;

public class RandomSelect extends Select{



    /**
     * Generates the file for Hadoop input.
     *
     * @param String
     * @param int
     * @return String
     */
    public String restrict(String query, int num) {
	
	String fileOutput ="";
	
	try { 

	    String allinput = Multisearch.getInput();
	    File file = new File(allinput);
	    File[] files = file.listFiles();

	    if(files.length <= num) {

		//then use all of them
		return(allinput);

	    } else {

		fileOutput = "q"+num;
		File out = new File(fileOutput);
		out.mkdir();

		//generate
		Random random = new Random();

		for(int x = 0; x < num; x++) {

		    int get = random.nextInt();

		    if(get < 0) {

			get = get * -1;

		    }

		    get = get % files.length;

		    if(files[get].isHidden() || files[get].isDirectory()) {

			x--;

		    } else {

			String newName = fileOutput + "/" + files[get].getName();
			File newFile = new File(newName);
			newFile.createNewFile();

			BufferedReader in = new BufferedReader(new FileReader(files[get]));
			BufferedWriter ot = new BufferedWriter(new FileWriter(newFile));

			while(in.ready()) {
			    
			    ot.write(in.readLine() + "\n");

			}

			in.close();
			ot.close();

		    }

		}

	    }

	    return(fileOutput);


	} catch(Exception e) {
	    
	    e.printStackTrace();
	    return(null);

	}

    }


}
