/*
 * ORDEREDLIST
 * A data structure that extends the normal OrderedList
 * Helpful for insertions, that is.
 * 
 * DATE CREATED: 25 July 2006
 * LAST UPDATED: 28 July 2006
 * AUTHOR: McCormick, Kylie
 * PROJECT: GridIR with Newby and Fallen
 *
 */
package edu.arsc.multisearch;

import java.util.LinkedList;

public class OrderedList extends LinkedList {

    /**
     * @return OrderedList
     */
    public OrderedList() {


    }


    /**
     * This will add Document objects by SCORE
     *
     * @param DocumentWritable newDocument
     */
    public void addRanked(DocumentWritable newDoc) {

	try {

	    if(isEmpty()) {

		addFirst(newDoc);

	    } else {

		double newDocScore = newDoc.getScore();
		DocumentWritable ptr = (DocumentWritable)getFirst();
		int indexAdd = -1;

		for(int x = 0; x < size() && ptr != null; x++) {

		    
		    if(ptr.getScore() > newDocScore) {

			ptr = (DocumentWritable)get(x);

		    } else {

			indexAdd = indexOf(ptr);
			x = size()+1; //to move us to the right place
		    }
		    
		    
		}

		//Now we must add it to the appropriate place
		 if(indexAdd > -1) {

		    add(indexAdd, newDoc);
		    
		} else {

		    //Then we were on the last one!
		    addLast(newDoc);
		}
	    }
	    

	} catch(Exception e) {
	    e.printStackTrace();
	}
    }


    /**
     * Set Ranks runs through the list and ensures a list of numbers in order
     */
    public void setRanks() {

	try {

	    DocumentWritable ptr = null;

	    for(int i = 0; i < size(); i++) {

		
		ptr = (DocumentWritable)get(i);
		ptr.setRank(i+1);
 
	    }

	} catch(Exception e) {

	    e.printStackTrace();
	}

    }
}
