/**
 * A {@link InputFormat} for Service XML files as defined in Multisearch.
 *
 * @author Kylie McCormick
 * @date 14 July 2008
 * @project Multisearch
 */
package edu.arsc.multisearch;

import java.io.IOException;
import org.apache.hadoop.mapred.FileInputFormat;
import org.apache.hadoop.mapred.JobConfigurable;
import org.apache.hadoop.fs.*;
import org.apache.hadoop.mapred.Reporter;
import org.apache.hadoop.mapred.JobConf;
import org.apache.hadoop.io.compress.CompressionCodecFactory;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.FileSplit;
import org.apache.hadoop.mapred.InputSplit;

public class ServiceInputFormat extends FileInputFormat<Text, ServiceWritable> implements JobConfigurable {

    private CompressionCodecFactory compressionCodecs = null;

    public void configure(JobConf conf) {

	compressionCodecs = new CompressionCodecFactory(conf);

    }

    protected boolean isSplitable(FileSystem fs, Path file) {

	return(compressionCodecs.getCodec(file) == null);

    }

    public ServiceRecordReader getRecordReader(InputSplit genericSplit,
					       JobConf job,
					       Reporter reporter) throws IOException {

	reporter.setStatus(genericSplit.toString());
	return(new ServiceRecordReader(job, (FileSplit)genericSplit));


    }


}
