/**
 * A class that reads the records provided by the generated service file
 * and makes them into useable InputSplits.
 *
 * @author Kylie McCormick
 * @date 16 July 2008
 * @project Multisearch
 */
package edu.arsc.multisearch;

import java.io.IOException;
import org.apache.hadoop.mapred.RecordReader;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FSDataInputStream;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.FileSplit;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.DataInputStream;
import java.io.BufferedReader;
import java.io.BufferedInputStream;
import java.io.InputStreamReader;
import java.io.StringReader;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.xml.sax.InputSource;

public class XMLTest {

    private FileInputStream fis;
    private BufferedInputStream bis;
    private DataInputStream in;

    public static void main(String args[]) {


	//xt.readService();

	try {
	    XMLTest xt = new XMLTest();	    

	    xt.readThis();
	    xt.readThis();
	    xt.readThis();

	    xt.close();

	} catch(Exception e) {
	    e.printStackTrace();
	}

    }

    public void close() {

       
	try {
	    bis.close();
	    fis.close();
	    in.close();

	} catch(Exception e) {
	    e.printStackTrace();
	}

    }


    public XMLTest() throws Exception {

	fis = new FileInputStream("/home/mccormic/merge/programs/inputfiles/xmlinput.txt");
	bis = new BufferedInputStream(fis);
	in = new DataInputStream(bis);

    }

    public void readThis() throws Exception{
	
	ServiceWritable sw = new ServiceWritable();
	String xmlstring = "";
	boolean complete = false;
	
	while(in.available() != 0 && !complete) {
	    
	    String input = in.readLine();
	    xmlstring += input;
	    
	    while(!input.equals("</service>")) {
		
		input = in.readLine();
		xmlstring += input;
		
	    } //end-while-not-xml-service-end
	    
	    DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	    DocumentBuilder db = factory.newDocumentBuilder();
	    InputSource instream = new InputSource();
	    instream.setCharacterStream(new StringReader(xmlstring));
	    org.w3c.dom.Document document = db.parse(instream);
	    
	    NodeList uNL = document.getElementsByTagName("url");
	    NodeList nNL = document.getElementsByTagName("name");
	    NodeList cNL = document.getElementsByTagName("clientclass");
	    
	    Node urlNode = uNL.item(0);
	    Node nameNode = nNL.item(0);
	    Node clientNode = cNL.item(0);
	    
	    org.w3c.dom.Text urlText = (org.w3c.dom.Text)urlNode.getFirstChild();
	    org.w3c.dom.Text nameText = (org.w3c.dom.Text)nameNode.getFirstChild();
	    org.w3c.dom.Text clientText = (org.w3c.dom.Text)clientNode.getFirstChild();
	    
	    String URL = urlText.getNodeValue().trim();
	    String name = nameText.getNodeValue().trim();
	    String client = clientText.getNodeValue().trim();
	    
	    sw.setURL(URL);
	    sw.setName(name);
	    sw.setClientClass(client);

	    System.out.println("XML: " + xmlstring);
	    
	    xmlstring = "";
	    complete = true;
	}

	System.out.println("Finished reading first one: ");
	System.out.println("Service @ " + sw.getURL() + " named " + sw.getName() + " and classed " + sw.getClientClass());

    }

    /**
     * Reads in an XML chunk that defines a service. &lt;service&gt;&lt;/service&gt;
     *
     * @param ServiceWritable to update
     * @throws java.io.IOException, javax.xml.parsers.ParserConfigurtionException, org.xml.sax.SAXException
     */
    public void readService() {

	try { 

	    FileInputStream fis = new FileInputStream("/home/mccormic/merge/programs/xmlinput.txt");
	    BufferedInputStream bis = new BufferedInputStream(fis);
	    DataInputStream in = new DataInputStream(bis);
	    
	    String xmlstring = "";
	 
            while(in.available() != 0) {

                String input = in.readLine();
		xmlstring += input;

                while(!input.equals("</service>")) {

		    input = in.readLine();
                    xmlstring += input;


                } //end-while-not-xml-service-end

		System.out.println(xmlstring);

                //mark our current position in the stream
                //in.mark(1000);
 
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = factory.newDocumentBuilder();
		InputSource inStream = new InputSource();
		inStream.setCharacterStream(new StringReader(xmlstring));
		org.w3c.dom.Document document = db.parse(inStream);
		
		NodeList uNL = document.getElementsByTagName("url");
		NodeList nNL = document.getElementsByTagName("name");
		NodeList cNL = document.getElementsByTagName("clientclass");
		
		Node urlNode = uNL.item(0);
		Node nameNode = nNL.item(0);
		Node clientNode = cNL.item(0);
		
		org.w3c.dom.Text urlText = (org.w3c.dom.Text)urlNode.getFirstChild();
		org.w3c.dom.Text nameText = (org.w3c.dom.Text)nameNode.getFirstChild();
		org.w3c.dom.Text clientText = (org.w3c.dom.Text)clientNode.getFirstChild();

		String URL = urlText.getNodeValue();
		String name = nameText.getNodeValue();
		String client = clientText.getNodeValue();

		xmlstring = "";
	    }

	    in.close();
	    bis.close();
	    fis.close();


	} catch(Exception e) {

	    e.printStackTrace();
	
	}
    }


}
