/*
 * AXISMULTISEARCHCLIENT
 * This makes a SOAPMessage/Axis Message out of the inputed
 * Query and then sends it across the wire to whatever point is wanted
 *
 *
 * AUTHOR: McCormick, Kylie
 * DATE CREATED: 1 August 2006
 * LAST UPDATED: 6 August 2006
 * PROJECT: GridIR with Fallen and Newby
 *
 */
package edu.arsc.multisearch.backend;

import java.io.*;
import java.util.*;
import javax.xml.*;
import org.apache.axis.soap.SOAPConnectionImpl;
import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.encoding.XMLType;
import org.apache.axis.utils.Options;
import org.apache.axis.client.*;
import org.apache.axis.Message;
import javax.xml.namespace.QName;
import org.apache.axis.encoding.ser.BeanSerializerFactory;
import org.apache.axis.encoding.ser.BeanDeserializerFactory;

public class AxisMultisearchClient {

    private String endpt;
    private String query;

    /*
     * CONSTRUCTOR
     * Make an AxisMultisearchClient
     *
     * INPUT: PrintWriter, Query
     * OUTPUT: New Object
     */
    public AxisMultisearchClient(String xQuery, String endpoint) {

	query = xQuery;
	endpt = endpoint;

    }

    /*
     * MAKECALL
     * Make the call to the Service, dude!
     *
     * INPUT: None
     * OUTPUT: None
     *
     */
    public ResultSet makeCall() {

	ResultSet rs = new ResultSet();

	//ResultSet resSet = new ResultSet(out);
	//edu.arsc.multisearch.backend.lucene.webservice.ResultSet wsResultSet = new edu.arsc.multisearch.backend.lucene.webservice.ResultSet();
	//LuceneBackend.ResultSet wsResultSet = new LuceneBackend.ResultSet();


	try {

	    Service service = new Service();
	    Call call = (Call)service.createCall();

	    //Let's make sure that the call knows how to deserialize the 
	    //given WebService items, in thisc ase LuceneBackend: ResultSet
	    QName qNameRS = new QName("urn:LuceneSeacher", "ResultSet");
	    BeanSerializerFactory bsfRS = new BeanSerializerFactory(edu.arsc.multisearch.backend.lemur.indriws.ResultSet.class, qNameRS);
	    BeanDeserializerFactory bdsfRS = new BeanDeserializerFactory(edu.arsc.multisearch.backend.lemur.indriws.ResultSet.class, qNameRS);
	    call.registerTypeMapping(edu.arsc.multisearch.backend.lemur.indriws.ResultSet.class, qNameRS, bsfRS, bdsfRS);
	    

	    //Making the call work!
	    call.setTargetEndpointAddress(new java.net.URL(endpt));
	    call.setOperationName(new QName("urn:LuceneSearcher", "search")); //Name of the function in LUCENEBACKEND
	    call.setReturnClass(edu.arsc.multisearch.backend.lemur.indriws.ResultSet.class);
	    call.setReturnType(qNameRS);
	    call.setUseSOAPAction(true);
	    call.setEncodingStyle(org.apache.axis.Constants.URI_SOAP11_ENC);
	    call.setSOAPVersion(org.apache.axis.soap.SOAPConstants.SOAP11_CONSTANTS);
	    call.addParameter("in0", XMLType.XSD_STRING, javax.xml.rpc.ParameterMode.IN);
	    call.addParameter("rss", qNameRS, edu.arsc.multisearch.backend.lemur.indriws.ResultSet.class, javax.xml.rpc.ParameterMode.OUT);

	    String[] params = new String[1];
	    params[0] = query;
	    
	    //Response response = call.invoke(params);
	  
	    edu.arsc.multisearch.backend.lemur.indriws.ResultSet wsResultSet = (edu.arsc.multisearch.backend.lemur.indriws.ResultSet)call.invoke(params);

	    //Now let's turn this into a -usable- object on this side
	    //there may be a way to get around this with Axis, but as 
	    //of 5 August 2006 I could not find a better way than this
	    //There may be a need to update this service to add ID#s,
	    //but the IDs don't stay the same on Lucene Anyway, so there
	    //might not be too much of a point...

	    edu.arsc.multisearch.backend.lemur.indriws.Document[] documents = wsResultSet.getResults();
	    Document[] xDocs = new Document[documents.length];

	    for(int q = 0; q < documents.length; q++) {

		xDocs[q] = new Document(documents[q].getRank(), 
					documents[q].getTitle(),
					documents[q].getScore(),
					documents[q].getFilename(),
					documents[q].getName());

	    }

	    rs.setResults(xDocs);
	    rs.setInfo(wsResultSet.getInfo());
	    rs.setName(wsResultSet.getName());
	    /*
	    String[] titles = wsResultSet.getTitles();
	    String[] mainContents = wsResultSet.getContents();
	    String[] filenames = wsResultSet.getFilenames();
	    double[] scores  = wsResultSet.getScores();
	    int[] ranks = wsResultSet.getRanks();
	    String server = wsResultSet.getServer();

	    for(int x = 0; x < wsResultSet.getNum(); x++) {

		Document makeDoc = new Document(titles[x], server, x, scores[x], filenames[x], ranks[x], 0, 0, 0);
		resSet.addResult(makeDoc);

	    }
	    */


	    /*	    if(wsResultSet != null) {

		edu.arsc.multisearch.backend.lucene.webservice.Document[] docs = wsResultSet.getResults();
		
		if(docs != null) {

		    System.out.println("There are " + docs.length + " in this result set.");

		    for(int i = 0; i < docs.length; i++) {

			System.out.println((i+1) + " " + docs[i].getFilename() + " " + docs[i].getScore());

		    }

		    System.out.println();
		}	

		System.out.println("Server name: " + wsResultSet.getName());
		System.out.println("Server info: " + wsResultSet.getInfo());

	    } else {

		System.out.println("Result set is null.");

	    }
	    */

	    return(rs);

	} catch(Exception e) {

 	    e.printStackTrace();

	}


	    return(rs);

	//	return(resSet);
    }
  
}
