/*
 * FINAL SET -- A collection of the  merged sets
 * It is modified as the new sets come along
 * 
 * DATE CREATED: 24 July 2006
 * LAST UPDATED: 7 Augsut 2006
 * AUTHOR: McCormick, Kylie
 * PROJECT: GridIR with Newby and Fallen
 *
 * NEEDED: OrderedList.java--Data Structure
 *
 */
package edu.arsc.multisearch.backend;

import java.io.PrintWriter;

public abstract class FinalSet {

    //Important Variables
    int totalResults;
    OrderedList rankedList;


    /*
     * ADDRESULT
     * Allows for the addition of DOCUMENT objects
     * in order, according to their score.
     * 
     * INPUT: A new document
     * OUTPUT: None
     * 
     */
    public void addResult(Document xDoc) {

	try {

	    rankedList.addRanked(xDoc);
	    totalResults = rankedList.size();
	    rankedList.setRanks();


	} catch(Exception e) {
	    e.printStackTrace();
	}
    }

    /*
     * PRINT
     * Prints out the resultset in order in a table
     * 
     * INPUT: None
     * OUTPUT: None
     * 
     
    public void print() {

	try {

	    if(rankedList.size() >= 1) {

		boolean colored;
		out.println("<p>A set of size " + rankedList.size() + "</p>");


		out.println("<table class=\"resPrint\">");
		out.println("<tr><td class=\"resnoCol\"><b>Rank</b></td>");
		

		out.println("<td class=\"resnoCol\"><b>Title</b></td>");
		out.println("<td class=\"resnoCol\"><b>Score</b></td>");
		out.println("<td class=\"resnoCol\"><b>Old Score</b></td>");
		out.println("<td class=\"resnoCol\"><b>Server</b></td>");
		out.println("<td class=\"resnoCol\"><b>Filename</b></td></tr>");

		for(int x = 0; x < rankedList.size(); x++) {
	       
		    Document doc = (Document)rankedList.get(x);

		    if(x % 2 == 0) {
			colored = true;
		    } else {
			colored = false;
		    }
		   
		    doc.printRes(out, colored);

		}
		
		out.println("</table>");
	    }
	    else {
		out.println("ERROR: There are no results from this set.");
	    }

	} catch(Exception e) {
	    e.printStackTrace();
	}


	}*/



    /* 
     * GET FUNCTIONS
     *
     * INPUT: None
     * OUTPUT: Object of Selection
     * 
     */
    public OrderedList getList() {
	return(rankedList);
    }

    public int getTotal() {
     
	return(totalResults);
    }

}
