/**
 * A class that defines the call specifications for an Axis service,
 * given a URI.
 *
 * @author Kylie McCormick
 * @date 10 July 2008
 *
 */
package edu.arsc.multisearch.backend;

import edu.arsc.multisearch.backend.lemur.indriws.*;

public class LemurIndriClient extends Client {


    /**
     * @return LemurIndriClient
     */
    public LemurIndriClient() {


    }


    /**
     * Calls the service and serializes the results
     *
     * @return ResultSet
     */
    public void call(String query)  {
    //throws javax.xml.rpc.ServiceException, java.rmi.RemoteException{

	try {

	    rsw = new ResultSetWritable();
	    
	    LemurIndriSearcherService service = new LemurIndriSearcherServiceLocator();
	    LemurIndriSearcher_PortType searcher = service.getLemurIndriSearcher();
	    edu.arsc.multisearch.backend.lemur.indriws.ResultSet rs = searcher.search(query);

	    if(service == null || searcher == null || rs == null) {

		throw new java.lang.NullPointerException("Service, searcher, or ResultSet are all null.");

	    }

	    /* Convert ResultSet to ResultSetWritable */
	    edu.arsc.multisearch.backend.lemur.indriws.Document[] docs = rs.getResults();

	    if(docs == null) {

		throw new java.lang.NullPointerException("Documents are null. Curses.");
	    
	    }
		

	    Document[] docX = new Document[docs.length];
	    
	    for(int x = 0; x < docs.length; x++) {
		
		//Convert documents!
		docX[x] = new Document(docs[x].getRank(),
				       docs[x].getTitle(),
				       docs[x].getScore(),
				       docs[x].getFilename(),
				       docs[x].getName());

	    }

	    //Set the RSW will all the appropriate information
	    rsw.setResults(docX);
	    rsw.setInfo(rs.getInfo());
	    rsw.setName(rs.getName());

	    if(rs == null) {
		System.out.println("ResultSet is null.");
	    }
       
	} catch(javax.xml.rpc.ServiceException se) {

	    se.printStackTrace();

	} catch(java.rmi.RemoteException re) {

	    re.printStackTrace();

	} catch(java.lang.NullPointerException npe) {

	    npe.printStackTrace();

	}

     

    }
  
}
