/**
 * A class that defines the call specifications for an Axis service,
 * given a URI.
 *
 * @author Kylie McCormick
 * @date 10 July 2008
 *
 */
package edu.arsc.multisearch.backend;

import edu.arsc.multisearch.backend.lucene.webservice.*;

public class LuceneClient extends Client {


    /**
     * @return LemurIndriClient
     */
    public LuceneClient() {


    }


    /**
     * Calls the service and serializes the results
     *
     * @return ResultSet
     */
    public void call(String query) {
    //throws javax.xml.rpc.ServiceException, java.rmi.RemoteException{

	try {
	    
	    rsw = new ResultSetWritable();
	    
	    LuceneSearcherService service = new LuceneSearcherServiceLocator();
	    LuceneSearcher_PortType searcher = service.getLuceneSearcher();
	    edu.arsc.multisearch.backend.lucene.webservice.ResultSet rs = searcher.search(query);
	    
	    /* Convert ResultSet to ResultSetWritable */
	    edu.arsc.multisearch.backend.lucene.webservice.Document[] docs = rs.getResults();
	    Document[] docX = new Document[docs.length];
	    
	    for(int x = 0; x < docs.length; x++) {
		
		//Convert documents!
		docX[x] = new Document(docs[x].getRank(),
				       docs[x].getTitle(),
				       docs[x].getScore(),
				       docs[x].getFilename(),
				       docs[x].getName());

	    }
	    
	    //Set the RSW will all the appropriate information
	    rsw.setResults(docX);
	    rsw.setInfo(rs.getInfo());
	    rsw.setName(rs.getName());
       
	} catch(javax.xml.rpc.ServiceException se) {

	    se.printStackTrace();


	} catch(java.rmi.RemoteException re) {

	    re.printStackTrace();

	}

    }
  
}
