/*
 * ORDEREDLIST
 * A data structure that extends the normal OrderedList
 * Helpful for insertions, that is.
 * 
 * Stores items of type DOCUMENT.
 *
 * DATE CREATED: 25 July 2006
 * LAST UPDATED: 28 July 2006
 * AUTHOR: McCormick, Kylie
 * PROJECT: GridIR with Newby and Fallen
 *
 */
package edu.arsc.multisearch.backend;

import java.util.LinkedList;
import java.io.PrintWriter;


public class OrderedList extends LinkedList {





    /*
     * CONSTRUCTOR FUNCTION
     * Creates a new OrderedQueue Object
     *
     * INPUT: PrintWriter
     * OUTPUT: New Object
     *
     */
    public OrderedList() {


    }


    /*
     * ADD
     * A function to add DOCUMENTS in the right place in the list
     * This will be done by RANK. 
     *
     * ASSUMPTION: Rank will be corrected to suit Multisearch 
     * before insertio
     *
     * INPUT: New Object
     * OUTPUT: None
     *
     */
    public void addRanked(Document newDoc) {

	try {

	    if(isEmpty()) {

		addFirst(newDoc);

	    } else {

		double newDocScore = newDoc.getScore();
		Document ptr = (Document)getFirst();
		int indexAdd = -1;

		for(int x = 0; x < size() && ptr != null; x++) {

		    
		    if(ptr.getScore() > newDocScore) {

			ptr = (Document)get(x);

		    } else {

			indexAdd = indexOf(ptr);
			x = size()+1; //to move us to the right place
		    }
		    
		    
		}

		//Now we must add it to the appropriate place
		 if(indexAdd > -1) {

		    add(indexAdd, newDoc);
		    
		} else {

		    //Then we were on the last one!
		    addLast(newDoc);
		}
	    }
	    

	} catch(Exception e) {
	    e.printStackTrace();
	}
    }


    /*
     * SETRANKS
     * This goes through the list and sets the ranks so that they correspond
     * with their scores correctly
     *
     * INPUT: None
     * OUTPUT: None
     *
     */
    public void setRanks() {

	try {

	    Document ptr = null;

	    for(int i = 0; i < size(); i++) {

		
		ptr = (Document)get(i);
		ptr.setRank(i+1);
 
	    }

	} catch(Exception e) {

	    e.printStackTrace();
	}

    }
}
