/**
 * An object that represents a multisearch result set that matches
 * to other searches in Multisearch. Can be serialized with NetBeans.
 *
 * @author Kylie McCormick
 * @date 2 July 2008
 * @project multisearch
 */
package edu.arsc.multisearch.backend;

import java.io.DataInput;
import java.io.DataOutput;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.conf.*;
import org.apache.hadoop.io.*;
import org.apache.hadoop.mapred.*;
import org.apache.hadoop.util.*;


public class ResultSetWritable implements Writable {

    /** Array of results, assumed in order. */
    private Document[] results;

    /** Name of the server/backend from which these results came.*/
    private String name;

    /** Any other information the server/backend wants to be known.*/
    private String info;

    /**
     * @param DataInput
     */
    public void readFields(DataInput input) {


    }

    /**
     * @param DataOutput
     */
    public void write(DataOutput output) {


    }

    /**
     * If value = 0, then the objects are the same
     * If value = 1, then this object is greater than the other
     * If value = -1, then this object is less t han the other
     *
     * @return int rank
     */
    public int compareTo(java.lang.Object obj) {

	int value = 0;

	return(value);

    }
     

    /**
     * Create a new resultset.
     *
     * @param Document[] results       the ordered documents
     * @param String name              the server name
     * @param String info              any additional information
     */
    public ResultSetWritable(Document[] results, String name, String info) {

	this.results = results;
	this.name = name;
	this.info = info;

    }

    /**
     * Make an empty instance.
     */
    public ResultSetWritable() {

	results = null;
	name = "";
	info = "This is an empty instance.";

    }

    /**
     * @return Document[] results
     */
    public Document[] getResults() {

	return(results);

    }

    /**
     * @return String name
     */
    public String getName() {

	return(name);

    }

    /**
     * @return String info
     */
    public String getInfo() {

	return(info);

    }

    /** 
     * @param String name
     */
    public void setName(String name) {

	this.name = name;

    }

    /**
     * @param String info
     */
    public void setInfo(String info) {

	this.info = info;

    }

    /**
     * @param Document[] results
     */
    public void setResults(Document[] results) {

	this.results = results;

    }

}
