/**
 * A very simple document object for the backends of Multisearch.
 * Contains the bare minimum for adding a document to Multisearch.
 *
 * @author Kylie McCormick
 * @project Multisearch
 *
 */
package edu.arsc.multisearch.backend.lemur;

import java.io.DataInput;
import java.io.DataOutput;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.conf.*;
import org.apache.hadoop.io.*;
import org.apache.hadoop.mapred.*;
import org.apache.hadoop.util.*;

public class DocumentWritable implements Writable {

    /** The title of the document */
    private String title = "untitled";

    /** The rank of the document. */
    private int rank;

   /** The score of the document */
    private double score;

    /** The filename of the document. */
    private String filename;

    /** The old rank of the document. */
    private int oldrank = 0;

    /** The old score of the document. */
    private double oldscore = 0.0;

    /** The backend name from which this document came. */
    private String name;

    /**
     * @param DataInput
     */
    public void readFields(DataInput input) {


    }

    /**
     * @param DataOutput
     */
    public void write(DataOutput output) {

    }

    /**
     * Make a new Document (bare bones) object.
     * 
     * @param int rank
     * @param String title
     * @param double score
     * @param String filename
     * @param String name
     */
    public DocumentWritable(int rank, String title, double score, String filename, String name) {

	this.rank = rank;
	this.oldrank = rank;
	this.title = title;
	this.score = score;
	this.oldscore = score;
	this.filename = filename;
	this.name = name;
       
    }

    /**
     * Make an empty document.
     *
     */
    public DocumentWritable() {

	rank = 0;
	oldrank = 0;
	title = "untitled";
	score = 0.0;
	oldscore = 0.00;
	filename = "";
	name = "";

    }

    /**
     * @return String filename
     */
    public String getFilename() {

	return(filename);

    }

    /**
     * @return String title
     */
    public String getTitle() {

	return(title);

    }
    /**
     * @return int rank
     */
    public int getRank() {

	return(rank);

    }

    /**
     * @return double score
     */
    public double getScore() {

	return(score);

    }

    /**
     * @return double oldscore
     */
    public double getOldScore() {

	return(oldscore);

    }

    /**
     * @return int oldrank
     */
    public int getOldRank() {
	
	return(oldrank);

    }

    /**
     * @return String name
     */
    public String getName() {

	return(name);

    }

    /**
     * @param int rank
     */
    public void setRank(int rank) {

	this.rank = rank;

    }

    /**
     * @param double score
     */
    public void setScore(double score) {

	this.score = score;

    }

}
