/**
 * An object to search a Lemur-made index.
 *
 * @author Kylie McCormick
 * @project Multisearch
 * @date 25 June 2008
 *
 */
package edu.arsc.multisearch.backend.lemur;

import lemurproject.lemur.*;

public class LemurKeySearcher {

    /** Base URI. **/
    private static String baseDir = "/home/mccormic/merge/indexes/lemur/key/gx200/gx200";

    /**
     * A main function to run from the command line
     *
     **/
    public static void main(String[] args) throws Exception {

	//String myIndex = args[0];
	String myIndex = "";
	myIndex = baseDir + myIndex;

	String myQuery = "";

	for(int i = 0; i < args.length; i++) {

	    myQuery += " " + args[i];

	}

	myQuery = myQuery.trim();


	//open the index
	try { 

	    Index index = IndexManager.openIndex(myIndex);

	    ArrayAccumulator scoreAccum = new ArrayAccumulator(index.docCount());
	    RetrievalMethod retMethod = RetMethodManager.createModel(index, scoreAccum, "okapi");
	    IndexedReal[] results = retMethod.runQuery(myQuery);

	    for(int x = 0; x < results.length && x < 1000; x++) {
		
		int resultID = results[x].ind;
		double resultScore = results[x].val;
		
		System.out.println((x+1) + " " + resultID + " " + resultScore);
		
	    }//end for-results

	} catch(Exception e) {

	    e.printStackTrace();
	
	}

    }

}
