/** 
 * FinalSet represents all the documents returned by various 
 * services across Multisearch. Anyone wanting to add a new
 * algorithm needs to extend this class.
 * <p>
 * DATE CREATED: 20 July 2006
 * LAST UPDATED: 25 July 2007
 *
 * @author Kylie McCormick
 */
package edu.arsc.multisearch.merge;

import edu.arsc.multisearch.*;
import java.io.File;
import java.io.PrintWriter;
import java.util.LinkedList;
import uk.org.ogsadai.common.msgs.DAILogger;

public class FinalSet {

    /** Final list of ranked documents to be printed */
    protected OrderedList rankedList;

    /** Total results generated in this entire merge. */
    protected int totalResults;

    /** Documents in an array. **/
    protected DocumentWritable[] results;


    /**
     * Creates a new FinalSet object.
     */
    public FinalSet() {

	totalResults = 0;
	rankedList = new OrderedList();

    }

    /**
     * Allows for reflection.
     */
    public FinalSet getInstance() {

	return(new FinalSet());
    }

    /**
     * A merge object based on the Naive Merge Algorithm.
     * 
     * @param DocumentWritable[] hits        the documents to be folded into the finalset
     * @return DocumentWritable[]
     */
    public synchronized void merge(DocumentWritable[] docs) {


    }

    /**
     * A function to retrieve the final result list
     *
     * @return OrderedList     The results of the merge
     */
    public OrderedList getList() {

	return(rankedList);
    }

    /**
     * A function to return the name of the Merge Algorithm.
     *
     * @return String 
     */
    public String getMergeAlgorithm() {

	return(new String(""));

    }

    /**
     * @return DocumentWritable[]
     */
    public DocumentWritable[] getResults() {

	return(results);
    }


}
