/**
 * A data structure that extends the normal LinkedList so that
 * objects can be added in some form of order.
 * <p>
 * Last Updated: 12 August 2008
 * <p>
 * @author Kylie McCormic
 * @version 3.0
 */
package edu.arsc.multisearch;

import java.util.LinkedList;
import java.util.Collections;

public class OrderedList extends LinkedList{


    /**
     * @return OrderedList
     */
    public OrderedList() {



    }


    /**
     * This will add Document objects by SCORE
     *
     * @param DocumentWritable newDocument
     */
    public void addRanked(DocumentWritable newDoc) {

	try {

	    if(isEmpty()) {

		addFirst(newDoc);

	    } else {

		//int indexAdd = findLocation(newDoc);
		int position = Collections.binarySearch(this, newDoc);


		//Now we must add it to the appropriate place
		if(position > -1) {
		    
		    add(position, newDoc);
		    
		} else {
		    
		    position = (position * -1) - 1;
		    
		    //Then we were on the last one!
		    add(position, newDoc);
		}


	    }

	} catch(Exception e) {
	    e.printStackTrace();
	}
    }

    /**
     * Set Ranks runs through the list and ensures a list of numbers in order
     */
    public void setRanks() {

	try {

	    DocumentWritable ptr = null;

	    for(int i = 0; i < size(); i++) {

		
		ptr = (DocumentWritable)get(i);
		ptr.setRank(i+1);
 
	    }

	} catch(Exception e) {

	    e.printStackTrace();
	}

    }


}
