/**
 * LeapOfFaithMerge does no reweighting or normalization
 * of the documents, it 
 * <p>
 * Last Updated: 31 July 2008
 * <p>
 *
 * @author Kylie McCormick
 * @version 3.0
 */
package edu.arsc.multisearch.merge;

import edu.arsc.multisearch.*;
import java.util.LinkedList;
import uk.org.ogsadai.common.msgs.DAILogger;

public class LeapOfFaithMergeSet extends FinalSet {

    /** OGSA-DAI Error Logger. */
    private static final DAILogger LOG = DAILogger.getLogger(LeapOfFaithMergeSet.class);

    /**
     * Creates a new NaiveMergeSet to allow merging of Documents
     */
    public LeapOfFaithMergeSet() {

	results = null;
	rankedList = new OrderedList();
	
    }

    /**
     * Allows for reflection.
     *
     * @return LeapOfFaithMergeSet
     */
    public LeapOfFaithMergeSet getInstance() {
	
	return(new LeapOfFaithMergeSet());
    }

    /**
     * A merge object based on the Naive Merge Algorithm.
     * 
     * @param DocumentWritable[] hits        the documents to be folded into the finalset
     */
    public void merge(DocumentWritable[] hits) {


	if(hits != null) {

	    for(int i = 0; i < hits.length; i++) {

		DocumentWritable doc = hits[i];
		doc.setScore(doc.getOldScore());
		rankedList.addRanked(doc);

	    }

	    rankedList.setRanks();

	        
	}

    }	

    /**
     * A function that returns the class name of this algorithm.
     * 
     * @return String className
     */
    public String getMergeAlgorithm() {

	return("edu.arsc.multisearch.merge.LeapOfFaithMergeSet");

    }

}
