/**
 * Client is a base class that can be extended for clients
 * to be added to Multisearch.
 * <p> 
 * Last Updated: 9 July 2008
 * <p>
 * @author Kylie McCormick
 * @version 3.0
 */
package edu.arsc.multisearch.client;

import edu.arsc.multisearch.*;

public class Client {

    /** URI of connection.*/
    protected String URL;

    /** The ResultSetWritable which has the results of this call. */
    protected ResultSetWritable rsw;

    /** The name of the service being contacted.*/
    protected String name;


    /**
     * Create a new client object.
     *
     * @return Client
     */
    public Client() {

	

    }

    /**
     * the function that allows reflection to work
     *
     * @return Cliet
     */
    public Client getInstance() {

	return(new Client());

    }

    /**
     * Call the service that uses this client.
     *
     * @param String query
     */
    public void call(String query) {


    }


    /**
     * Set the URI
     *
     * @param String URI
     */
    public void setURL(String URL) {

	this.URL = URL;

    }

    /**
     * @return String URL
     */
    public String getURL() {

	return(URL);

    }

    
    /**
     * Get the ResultSet from this object.
     * 
     * @return ResultSetWritable
     */
    public ResultSetWritable getResultSet() {

	return(rsw);

    }

    /**
     * Set the name.
     * @param String name
     */
    public void setName(String name) {

	this.name = name;

    }

    /**
     * Get name.
     *
     * @return String name
     */
    public String getName() {

	return(name);

    }

}
