/** 
 * FinalSet represents all the documents returned by various 
 * services across Multisearch. Anyone wanting to add a new
 * algorithm needs to extend this class.
 * <p>
 * Last Updated: 28 July 2008
 *
 * @author Kylie McCormick
 * @version 3.0
 */
package edu.arsc.multisearch.merge;

import edu.arsc.multisearch.*;
import java.io.File;
import java.util.LinkedList;


public class FinalSet {

    /** Final list of ranked documents to be printed */
    protected OrderedList rankedList;

    /** Documents in an array. **/
    protected DocumentWritable[] results;


    /**
     * Creates a new FinalSet object.
     */
    public FinalSet() {

	results = null;
	rankedList = new OrderedList();

    }

    /**
     * Allows for reflection.
     */
    public FinalSet getInstance() {

	return(new FinalSet());
    }

    /**
     * A merge object based on the Naive Merge Algorithm.
     * 
     * @param DocumentWritable[] hits        the documents to be folded into the finalset
     * @return DocumentWritable[]
     */
    public synchronized void merge(DocumentWritable[] docs) {


    }

    /**
     * A function to retrieve the final result list
     *
     * @return OrderedList     The results of the merge
     */
    public OrderedList getList() {

	return(rankedList);
    }

    /**
     * A function to return the name of the Merge Algorithm.
     *
     * @return String 
     */
    public String getMergeAlgorithm() {

	return(new String(""));

    }

    /**
     * Return the documents as a results
     *
     * @return DocumentWritable[]
     */
    public DocumentWritable[] getResults() {
	    
	DocumentWritable[] results = new DocumentWritable[rankedList.size()];
	
	for(int z = 0; z < rankedList.size(); z++) {
	    
	    results[z] = (DocumentWritable)rankedList.get(z);
	    
	}

	return(results);
	
    }


}
